'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BSInputWrapper = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _InputError = require('./InputError');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var renderLabel = function renderLabel(props) {
  var _classnames;

  var labelClasses = (0, _classnames3.default)('control-label', (_classnames = {}, _defineProperty(_classnames, 'pt-0', props.labelTop && props.horizontal), _defineProperty(_classnames, 'col-form-label', props.horizontal), _defineProperty(_classnames, 'col-sm-3', props.horizontal), _classnames));
  var $labelComponent = props.fieldset ? 'legend' : 'label';

  return _react2.default.createElement(
    $labelComponent,
    { className: labelClasses, 'data-required': props.required },
    props.label
  );
};

var renderError = function renderError(message) {
  if (message) {
    return _react2.default.createElement(
      'div',
      { className: 'invalid-feedback' },
      message
    );
  } else return null;
};

var renderWarning = function renderWarning(message) {
  if (message) {
    return _react2.default.createElement(
      'small',
      { className: 'form-text' },
      message
    );
  } else return null;
};

var renderElement = function renderElement(props, wrapperClasses) {
  return _react2.default.createElement(
    'div',
    { className: wrapperClasses },
    props.children,
    _react2.default.createElement(_InputError.InputError, {
      errorMessage: props.errorMessage,
      warningMessage: props.warningMessage
    })
  );
};

var BSInputWrapper = exports.BSInputWrapper = function BSInputWrapper(props) {
  var label = props.label ? renderLabel(props) : null;
  var wrapperClasses = 'wrapperClassName' in props ? props.wrapperClassName : (0, _classnames3.default)({
    'col-sm-9': props.horizontal && !props.inline,
    'col-sm-10': props.inline
  });
  var groupClasses = (0, _classnames3.default)({
    'form-group': !props.inline,
    row: props.horizontal && !props.inline
  });

  var element = renderElement(props, wrapperClasses);
  var $grouper = props.fieldset ? 'fieldset' : 'div';

  if (props.elementOnly) {
    return _react2.default.createElement(
      $grouper,
      { className: groupClasses },
      element
    );
  } else {
    return _react2.default.createElement(
      $grouper,
      { className: groupClasses },
      label,
      element
    );
  }
};

BSInputWrapper.propTypes = {
  label: _propTypes2.default.string,
  horizontal: _propTypes2.default.bool,
  required: _propTypes2.default.bool,
  elementOnly: _propTypes2.default.bool,
  inline: _propTypes2.default.bool,
  fieldset: _propTypes2.default.bool,
  labelTop: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  errorMessage: _propTypes2.default.any,
  warningMessages: _propTypes2.default.any
};