'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('./Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderContent = function renderContent(_ref) {
  var iconClass = _ref.iconClass,
      text = _ref.text;

  if (iconClass) {
    return _react2.default.createElement(_Icon.Icon, {
      className: iconClass,
      text: text
    });
  } else return text;
};

var buttonType = function buttonType(_ref2) {
  var submit = _ref2.submit;
  return submit ? 'submit' : 'button';
};

var handleClick = function handleClick(_ref3, e) {
  var disabled = _ref3.disabled,
      onClick = _ref3.onClick;

  if (!disabled && onClick) onClick(e);
};

var Button = exports.Button = function Button(_ref4) {
  var _ref4$text = _ref4.text,
      text = _ref4$text === undefined ? '' : _ref4$text,
      onFocus = _ref4.onFocus,
      onClick = _ref4.onClick,
      className = _ref4.className,
      iconClass = _ref4.iconClass,
      submit = _ref4.submit,
      disabled = _ref4.disabled,
      small = _ref4.small,
      extraSmall = _ref4.extraSmall;

  var buttonClass = className || 'btn-default';
  var classes = (0, _classnames2.default)('btn', buttonClass, {
    disabled: disabled,
    'btn-sm': small,
    'btn-xs': extraSmall
  });

  return _react2.default.createElement(
    'button',
    {
      'aria-hidden': 'true',
      type: buttonType({ submit: submit }),
      className: classes,
      onClick: handleClick.bind(null, { disabled: disabled, onClick: onClick }),
      onFocus: onFocus
    },
    renderContent({ iconClass: iconClass, text: text })
  );
};

Button.propTypes = {
  text: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  className: _propTypes2.default.string,
  iconClass: _propTypes2.default.string,
  submit: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool
};