'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckboxWrapper = exports.Checkbox = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxFormAuto = require('redux-form-auto');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _InputError = require('./InputError');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var renderSeparator = function renderSeparator(horizontal) {
  if (horizontal) return _react2.default.createElement('div', { key: 'sep', className: 'col-sm-3' });else return null;
};

var renderInputs = function renderInputs(_ref) {
  var id = _ref.id,
      horizontal = _ref.horizontal,
      label = _ref.label,
      input = _ref.input,
      messages = _ref.messages;

  var classes = (0, _classnames2.default)('custom-control', 'custom-checkbox', {
    'form-check': false
  });

  var inputClasses = (0, _classnames2.default)('custom-control-input', {
    'is-invalid': messages && messages.touched && messages.error
  });

  return _react2.default.createElement(
    'div',
    { className: classes },
    _react2.default.createElement('input', _extends({
      key: 'input',
      id: id,
      className: inputClasses
    }, input, {
      type: 'checkbox'
    })),
    _react2.default.createElement(
      'label',
      { key: 'label', className: 'custom-control-label', htmlFor: id },
      label
    ),
    _react2.default.createElement(_InputError.InputError, { key: 'errors', messages: messages })
  );
};

var renderInputsGroup = function renderInputsGroup(params) {
  var horizontal = params.horizontal;

  var inputs = renderInputs(params);

  var style = horizontal ? { paddingLeft: 0 } : null;

  if (horizontal) {
    return _react2.default.createElement(
      'div',
      { key: 'inputs', className: 'col-sm-9', style: style },
      inputs
    );
  } else return inputs;
};

var Checkbox = exports.Checkbox = function (_PureComponent) {
  _inherits(Checkbox, _PureComponent);

  function Checkbox() {
    _classCallCheck(this, Checkbox);

    return _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).apply(this, arguments));
  }

  _createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          input = _props.input,
          name = _props.input.name,
          horizontal = _props.config.horizontal,
          messages = _props.messages,
          schemaTypeName = _props.schemaTypeName;


      var id = schemaTypeName + '-' + name;
      var label = (0, _reduxFormAuto.trModel)(schemaTypeName, name);

      var classes = (0, _classnames2.default)('form-group', {
        row: horizontal
      });

      return _react2.default.createElement(
        'div',
        { className: classes },
        renderSeparator(horizontal),
        renderInputsGroup({ id: id, horizontal: horizontal, label: label, input: input, messages: messages })
      );
    }
  }]);

  return Checkbox;
}(_react.PureComponent);

var CheckboxWrapper = exports.CheckboxWrapper = function CheckboxWrapper(_ref2) {
  var children = _ref2.children;

  return _react2.default.createElement(
    'div',
    { className: 'form-group' },
    children
  );
};