'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputArrayPanel = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _Panel = require('./Panel');

var _Button = require('./Button');

var _renderLectures = require('./renderLectures');

var _reduxFormAuto = require('redux-form-auto');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderItemHeader = function renderItemHeader(_ref) {
  var onRemove = _ref.onRemove,
      fields = _ref.fields,
      idx = _ref.idx;
  return _react2.default.createElement(
    _Button.Button,
    {
      onClick: onRemove.bind(null, fields, idx),
      text: '\u274C',
      className: 'btn-danger',
      small: true
    },
    '\xD7'
  );
};

var renderInputs = function renderInputs(props) {
  var fields = props.fields,
      onRemove = props.onRemove,
      children = props.children;


  return fields.map(function (field, idx) {
    var header = renderItemHeader({ fields: fields, onRemove: onRemove, idx: idx });

    return _react2.default.createElement(
      _Panel.Panel,
      { key: idx, header: header },
      props.instrumentChildren({ field: field, idx: idx, children: children })
    );
  });
};

var renderHeader = function renderHeader(props) {
  var schemaTypeName = props.schemaTypeName,
      fields = props.fields,
      onAdd = props.onAdd,
      newObject = props.newObject;

  var boundAdd = onAdd.bind(null, fields, newObject);

  return _react2.default.createElement(
    'span',
    null,
    (0, _reduxFormAuto.trModel)(schemaTypeName, fields.name) + ' ',
    _react2.default.createElement(_Button.Button, {
      className: 'btn-success',
      onClick: boundAdd,
      iconClass: 'plus',
      text: '\uD83D\uDFA4',
      small: true
    })
  );
};

var InputArrayPanel = exports.InputArrayPanel = function InputArrayPanel(props) {
  var meta = props.meta;


  return _react2.default.createElement(
    _Panel.Panel,
    { header: renderHeader(props) },
    (0, _renderLectures.renderLectures)(meta),
    renderInputs(props)
  );
};

InputArrayPanel.propTypes = {
  onAdd: _propTypes.PropTypes.func.isRequired,
  onRemove: _propTypes.PropTypes.func.isRequired,
  instrumentChildren: _propTypes.PropTypes.func.isRequired
};