'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputArrayTable = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _Panel = require('./Panel');

var _Button = require('./Button');

var _renderLectures = require('./renderLectures');

var _reduxFormAuto = require('redux-form-auto');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var renderCloser = function renderCloser(_ref) {
  var fields = _ref.fields,
      idx = _ref.idx,
      onRemove = _ref.onRemove;
  return _react2.default.createElement(_Button.Button, {
    onClick: onRemove.bind(null, fields, idx),
    className: 'btn-danger',
    text: '\u274C',
    small: true
  });
};

var addRemove = function addRemove(_ref2) {
  var field = _ref2.field,
      idx = _ref2.idx,
      children = _ref2.children,
      instrumentChildren = _ref2.instrumentChildren,
      onRemove = _ref2.onRemove,
      fields = _ref2.fields;

  var instrumented = instrumentChildren({ field: field, idx: idx, children: children });
  var closer = renderCloser({ fields: fields, idx: idx, onRemove: onRemove });
  var childrenAndClose = [closer].concat(_toConsumableArray(instrumented));

  return childrenAndClose.map(function (child, childIdx) {
    var inlinedChild = (0, _react.cloneElement)(child, {
      elementOnly: true,
      inline: true
    });

    return _react2.default.createElement(
      'td',
      {
        key: childIdx,
        className: 'form-col-' + (childIdx + 1)
      },
      inlinedChild
    );
  });
};

var renderInputs = function renderInputs(props) {
  return props.fields.map(function (field, idx) {
    return _react2.default.createElement(
      'tr',
      { key: idx },
      addRemove(_extends({}, props, { field: field, idx: idx }))
    );
  });
};

var renderTable = function renderTable(props) {
  return _react2.default.createElement(
    'table',
    { className: 'table table-striped' },
    _react2.default.createElement(
      'tbody',
      null,
      renderInputs(props)
    )
  );
};

var renderHeader = function renderHeader(onFocus, onAdd) {
  return _react2.default.createElement(_Button.Button, {
    className: 'btn-success',
    onFocus: onFocus,
    onClick: onAdd,
    iconClass: 'plus',
    text: (0, _reduxFormAuto.tr)('add'),
    small: true
  });
};

var InputArrayTable = exports.InputArrayTable = function InputArrayTable(props) {
  var onAdd = props.onAdd,
      fields = props.fields,
      newObject = props.newObject,
      addOnButtonFocus = props.addOnButtonFocus,
      meta = props.meta;


  var boundAdd = onAdd.bind(null, fields, newObject);
  var onFocus = addOnButtonFocus ? boundAdd : null;

  return _react2.default.createElement(
    _Panel.Panel,
    { table: renderTable(props), header: renderHeader(onFocus, boundAdd) },
    (0, _renderLectures.renderLectures)(meta)
  );
};