'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Panel = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderChildren = function renderChildren(noMargin, children) {
  if (noMargin) return children;else {
    return _react2.default.createElement(
      'div',
      { className: 'card-body' },
      children
    );
  }
};

var renderHeader = function renderHeader(header) {
  if (header) {
    return _react2.default.createElement(
      'div',
      { className: 'card-header' },
      header
    );
  } else return null;
};

var getClasses = function getClasses(_ref) {
  var panelType = _ref.panelType,
      borderType = _ref.borderType,
      className = _ref.className;

  var typeIsDefault = !panelType || panelType == 'default';
  var typeClass = typeIsDefault ? '' : 'bg-' + panelType;
  var textClass = typeIsDefault ? 'text-dark' : 'text-white';
  var buttonClass = className || '';

  var borderIsDef = !borderType || borderType == 'default';
  var borderClass = borderIsDef ? '' : 'border-' + borderType;

  return (0, _classnames2.default)('card', typeClass, textClass, buttonClass, borderClass);
};

var Panel = exports.Panel = function Panel(_ref2) {
  var header = _ref2.header,
      _ref2$table = _ref2.table,
      table = _ref2$table === undefined ? null : _ref2$table,
      className = _ref2.className,
      panelType = _ref2.panelType,
      borderType = _ref2.borderType,
      noMargin = _ref2.noMargin,
      onClick = _ref2.onClick,
      children = _ref2.children;

  var classes = getClasses({ panelType: panelType, borderType: borderType, className: className });

  return _react2.default.createElement(
    'div',
    {
      className: classes,
      onClick: onClick
    },
    renderHeader(header),
    renderChildren(noMargin, children),
    table
  );
};

Panel.propTypes = {
  header: _propTypes2.default.node,
  table: _propTypes2.default.node,
  className: _propTypes2.default.string,
  panelType: _propTypes2.default.string,
  onClick: _propTypes2.default.func
};