'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputArrayWrap = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reduxForm = require('redux-form');

var _reduxFormAuto = require('redux-form-auto');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var instrumentChildren = function instrumentChildren(_ref) {
  var field = _ref.field,
      idx = _ref.idx,
      children = _ref.children;

  return children.map(function (child, inputIdx) {
    var _child$props = child.props,
        name = _child$props.name,
        rest = _objectWithoutProperties(_child$props, ['name']);

    var newName = field + '.' + name;

    return (0, _react.cloneElement)(child, _extends({
      name: newName,
      key: inputIdx
    }, rest));
  });
};

var handleAdd = function handleAdd(schema, fields) {
  var newObject = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var useObject = (0, _reduxFormAuto.mergeInitialValues)(newObject, schema);
  fields.push(useObject);
};

var handleRemove = function handleRemove(fields, idx) {
  fields.remove(idx);
};

/**
 * Used for the arrays in models, for
 * example clients: [Clients]
 *
 */
var InputArrayWrap = function InputArrayWrap(_ref2) {
  var name = _ref2.name,
      children = _ref2.children,
      propOverrides = _ref2.propOverrides,
      newObject = _ref2.newObject,
      arrayHandler = _ref2.arrayHandler,
      fieldSchema = _ref2.fieldSchema,
      rest = _objectWithoutProperties(_ref2, ['name', 'children', 'propOverrides', 'newObject', 'arrayHandler', 'fieldSchema']);

  var schema = fieldSchema.type[0];

  return _react2.default.createElement(
    _reduxForm.FieldArray,
    _extends({
      name: name,
      component: arrayHandler,
      onAdd: handleAdd.bind(null, schema),
      onRemove: handleRemove,
      instrumentChildren: instrumentChildren,
      newObject: newObject
    }, rest),
    children
  );
};

exports.InputArrayWrap = InputArrayWrap;
InputArrayWrap.propTypes = {
  name: _propTypes2.default.string,
  type: _propTypes2.default.string,
  children: _propTypes2.default.array.isRequired,
  newObject: _propTypes2.default.object
};