'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputWrap = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reduxForm = require('redux-form');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reduxFormAuto = require('redux-form-auto');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputBase = function (_Component) {
  _inherits(InputBase, _Component);

  function InputBase() {
    _classCallCheck(this, InputBase);

    return _possibleConstructorReturn(this, (InputBase.__proto__ || Object.getPrototypeOf(InputBase)).apply(this, arguments));
  }

  _createClass(InputBase, [{
    key: 'focus',
    value: function focus() {
      this.inputControl.focus();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          input = _props.input,
          inputWrapper = _props.inputWrapper,
          inputComponent = _props.inputComponent,
          required = _props.required,
          config = _props.config,
          horizontal = _props.config.horizontal,
          elementOnly = _props.elementOnly,
          inline = _props.inline,
          fieldset = _props.fieldset,
          labelTop = _props.labelTop,
          type = _props.type,
          autoFocus = _props.autoFocus,
          className = _props.className,
          schemaTypeName = _props.schemaTypeName,
          onKeyDown = _props.onKeyDown,
          onKeyPress = _props.onKeyPress,
          labelOverride = _props.labelOverride,
          componentPropMap = _props.componentPropMap,
          wrapperClassName = _props.wrapperClassName,
          provideMessages = _props.provideMessages,
          meta = _props.meta,
          _props$meta = _props.meta,
          touched = _props$meta.touched,
          error = _props$meta.error,
          warning = _props$meta.warning,
          rest = _objectWithoutProperties(_props, ['children', 'input', 'inputWrapper', 'inputComponent', 'required', 'config', 'config', 'elementOnly', 'inline', 'fieldset', 'labelTop', 'type', 'autoFocus', 'className', 'schemaTypeName', 'onKeyDown', 'onKeyPress', 'labelOverride', 'componentPropMap', 'wrapperClassName', 'provideMessages', 'meta', 'meta']);

      var $wrapper = inputWrapper;
      var $input = inputComponent || 'input';
      var inputIsClass = typeof inputComponent == 'function';
      var providedRest = componentPropMap ? componentPropMap(this.props) : inputIsClass ? _extends({}, rest, {
        input: input,
        meta: meta,
        config: config,
        autoFocus: autoFocus,
        schemaTypeName: schemaTypeName
      }) : input;

      if (provideMessages) {
        providedRest.messages = {
          touched: touched,
          error: error,
          warning: warning
        };
      }

      var noWrap = type == 'hidden' || elementOnly;
      var fieldName = (0, _reduxFormAuto.arrLast)(input.name.split('.'));
      var label = typeof labelOverride != 'undefined' ? labelOverride : (0, _reduxFormAuto.trModel)(schemaTypeName, fieldName, '_field');
      var placeholder = noWrap ? label : null;
      var errorMessage = touched && error;
      var warningMessage = touched && warning;
      var inputClasses = (0, _classnames2.default)('form-control', className, {
        'is-invalid': errorMessage
        // 'is-valid': (touched && !error && !warning)
      });

      return _react2.default.createElement(
        $wrapper,
        {
          label: label,
          required: required,
          horizontal: horizontal,
          inline: inline,
          fieldset: fieldset,
          labelTop: labelTop,
          errorMessage: errorMessage,
          warningMessage: warningMessage,
          elementOnly: noWrap,
          wrapperClassName: wrapperClassName
        },
        _react2.default.createElement(
          $input,
          _extends({
            className: inputClasses,
            type: type || 'text',
            onKeyDown: onKeyDown,
            onKeyPress: onKeyPress
          }, providedRest, {
            autoComplete: 'off',
            placeholder: placeholder,
            ref: function ref(element) {
              return _this2.inputControl = element;
            }
          }),
          children
        )
      );
    }
  }]);

  return InputBase;
}(_react.Component);

var InputWrap = exports.InputWrap = function (_Component2) {
  _inherits(InputWrap, _Component2);

  function InputWrap() {
    _classCallCheck(this, InputWrap);

    return _possibleConstructorReturn(this, (InputWrap.__proto__ || Object.getPrototypeOf(InputWrap)).apply(this, arguments));
  }

  _createClass(InputWrap, [{
    key: 'focus',
    value: function focus() {
      this.fieldElement.getRenderedComponent().focus();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      return _react2.default.createElement(_reduxForm.Field, _extends({
        component: InputBase,
        ref: function ref(el) {
          return _this4.fieldElement = el;
        },
        withRef: true
      }, this.props));
    }
  }]);

  return InputWrap;
}(_react.Component);

/**
 * Skin input propTypes.
 * @typedef {object} InputPropTypes
 */


InputWrap.propTypes = {
  children: _propTypes2.default.node,
  name: _propTypes2.default.string.isRequired,
  fieldSchema: _propTypes2.default.object,
  schemaTypeName: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string,
  inputComponent: _propTypes2.default.any,
  required: _propTypes2.default.bool,
  horizontal: _propTypes2.default.bool,
  elementOnly: _propTypes2.default.bool,
  type: _propTypes2.default.string
};